//
//	$Date: 2001/03/28 10:50:30 $
//	$Revision: 1.32 $
//
//	QPocket Version 0.2.2
//

#pragma pack(2)
#include <Pilot.h>

#include "DropModule.h" // Drag&Drop⥸塼ѥإå

#include "acsearch.h"
#include "id.h"

// Inline POBoxʤ
#define DICTYPE 'EDIC'
#define LDICTYPE 'LDIC'
#define POBOXCREATOR 'PBIN'
DmOpenRef dic;                // POBoxInline 
DmOpenRef ldic;               // ؽñDB

#define MAXEXTRA 0x100
unsigned char extra[MAXEXTRA];
int nextra;

LocalID memodbid;
LocalID memoappid;
unsigned short memodbcardno;
unsigned short memoappcardno;

enum {
	NEWSEARCH=1,
	NEXTSEARCH,
	PREVSEARCH
};

#define MAXLINES 12
#define MAXMATCHEDRECORDS 240
int memorecord[MAXMATCHEDRECORDS];	// ޥå쥳ֹΥꥹ
int memorecordpos[MAXMATCHEDRECORDS];	// ޥå
int nmatchedrecords;			// η̥ޥå쥳ɤο (ޤ)
int dispindex;				// ɽϥǥ
Boolean searchisdone = false;		// 쥳ɤθλ

void SearchInit();			//  - ˸򳫻Ϥ
void SearchMemo();			// dispindex1ڡʬmemorecord[]˳Ǽ
void Display();				// dispindex1ڡʬɽ 
void LaunchMemo(int recordno, int pos);

char defaultsearchpat[4][16];

typedef struct {
	char searchpat[16];
	char memo[5];
	int movetop;
} QPPref;
QPPref pref;

FieldPtr patfield;            // ѥե

static unsigned long StringToLong(char *s)
{
	unsigned long val = 0;
	int i;
	for(i=0;i<4;i++){
		val = ((val << 8) + s[i]);
	}
	return val;
}

static WinHandle DrawIndicator(int sel, WinHandle savedBits, int draw)
{
	UShort i;
	UShort err;
	WinHandle winH = 0;
	RectangleType indrect;
	CustomPatternType pattern;
	CustomPatternType savedPattern;

	if(sel-dispindex >= MAXLINES) return NULL; // without this, fatal error!!
	RctSetRectangle(&indrect,2,(sel-dispindex)*10+31+9,152,2);

	if(draw){
		WinGetPattern (&savedPattern);
		for(i=0;i<sizeof(CustomPatternType)/sizeof(*pattern);i++){
//			pattern[i]= 0xAA55;
			pattern[i]= 0xAAAA;
		}
		WinSetPattern(&pattern);
		winH = WinSaveBits(&indrect,&err);
		WinFillRectangle (&indrect, 0);
		WinSetPattern (&savedPattern);
	}
	else {
if(savedBits)
		WinRestoreBits(savedBits,indrect.topLeft.x,indrect.topLeft.y);
	}
	return winH;
}

static int CreateNewRecord(int oldrecord)
{
	DmOpenRef memo;
	VoidHand h,hnew;
	int nrecords;
	ULong size;
	char *s0, *snew;
	UInt at;
	Err err;
	UShort attr;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	nrecords = DmNumRecords(memo);
	h = DmQueryRecord(memo,oldrecord);
	if(h && (s0 = MemHandleLock(h))){
		DmRecordInfo(memo,oldrecord,&attr,NULL,NULL);
		size = MemPtrSize(s0);
		at = nrecords;
		hnew = DmNewRecord(memo,&at,size);
		if(hnew && (snew = MemHandleLock(hnew))){
			err = DmWrite(snew,0,s0,size);
			ErrFatalDisplayIf(err,"DmWrite");
			DmReleaseRecord(memo,at,true);
			DmSetRecordInfo(memo,at,&attr,NULL);
			MemHandleUnlock(hnew);
		}
		else {
			at = -1;
		}
		MemHandleUnlock(h);
	}
	else {
		at = -1;
	}
	DmCloseDatabase(memo);
	return at;
}

static void MoveRecord(int from, int to)
{
	DmOpenRef memo;
	int nrecords;
	int newrecordno;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	nrecords = DmNumRecords(memo);

	if(to < 0){
		newrecordno = nrecords/*-1*/;
	}
	else {
		newrecordno = memorecord[to];
	}

	DmMoveRecord(memo,memorecord[from],newrecordno);

	DmCloseDatabase(memo);

	SearchInit();
	SearchMemo();
	Display();
}

static Boolean SelectMemo(EventPtr e)
{
	short x,y;
	Boolean pendown = true;
	Boolean moving = false;
	RectangleType selrect;
	int sel,newsel,origrecord;
	WinHandle w;
	int recordno;
	int dispmax;
	int origsel;
	int indpos;

	dispmax = dispindex + MAXLINES;
	if(dispmax > nmatchedrecords) dispmax = nmatchedrecords;

	sel = dispindex + (e->screenY / 10 - 3);

	if(sel < dispindex || sel >= dispmax) return false;

	origsel = sel;
	origrecord = memorecord[origsel];

	RctSetRectangle(&selrect,0,(sel-dispindex)*10+31,156,10);
	WinInvertRectangle(&selrect,0);

	while(true){
		EvtGetPen(&x,&y,&pendown);
		if(!pendown) break;

		newsel = dispindex + (y / 10 - 3);
		if(dispindex - newsel > 1){ // 
			if(!moving){
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			if(dispindex > 0){
				w = DrawIndicator(indpos,w,false);

				dispindex--;
				Display();

				if(origsel >= dispindex && origsel < dispmax){
					RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
					WinInvertRectangle(&selrect,0);
				}

				w = DrawIndicator(dispindex-1,NULL,true);
				indpos = dispindex-1;
			}
		}
		else if(newsel - dispmax >= 0){ // 她
			if(!moving){
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			if(dispindex < nmatchedrecords-1){
				w = DrawIndicator(indpos,w,false);

				dispindex++;
				SearchMemo();

				Display();

				if(origsel >= dispindex && origsel < dispmax){
					RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
					WinInvertRectangle(&selrect,0);
				}

				w = DrawIndicator(dispmax,NULL,true);
				indpos = dispmax;
			}
		}
		else if(newsel != sel){
			if(moving){
				w = DrawIndicator(indpos,w,false);
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			else {
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
		}
		dispmax = dispindex + MAXLINES;
		if(dispmax > nmatchedrecords) dispmax = nmatchedrecords;

		sel = newsel;

	}
	if(moving){
		w = DrawIndicator(indpos,w,false);
	}

	if(origsel >= dispindex && origsel < dispmax){
		RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
		WinInvertRectangle(&selrect,0);
	}
//	WinInvertRectangle(&selrect,0);

	if(moving){
		if(sel != origsel){
			MoveRecord(origsel,sel);
		}
	}
	else {
		recordno = memorecord[sel];
		if(x - e->screenX > 10){ // Copy existing data and make another
			recordno = CreateNewRecord(recordno);
			SearchInit();
			SearchMemo();
			Display();
		}
		else if(recordno >= 0){ // normal
			DmOpenRef memo;
			int n;
			UShort attr;
			if(pref.movetop){
				memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
				n = DmNumRecords(memo);
//				DmMoveRecord(memo,recordno,n-1);
				DmMoveRecord(memo,recordno,n);
				// ֹˤȰưʤȤ褦ʤΤ
				// ǿΥ쥳ɤ˥פ
//				for(n--;n>=0;n--){
				for(;n>=0;n--){
					if(DmQueryRecord(memo,n)){
						DmRecordInfo(memo,n,&attr,NULL,NULL);
						if((attr & dmRecAttrDelete) || attr & dmRecAttrSecret)
							continue;
						else
							break;
					}
				}
				DmCloseDatabase(memo);
				if(n >= 0) LaunchMemo(n,memorecordpos[sel]);
			}
			else {
				LaunchMemo(recordno,memorecordpos[sel]);
			}
		}
	}

	return true;
}

static Boolean MainFormEvent(EventPtr e)
{
	Boolean handled = true;
	Word c;
	int i;
	RectangleType r;

	switch(e->eType){
	case fldChangedEvent:
		dispindex = 0;
		SearchInit();
		SearchMemo();
		Display();
		break;


	case keyDownEvent:
		if(c >= 0x20 && c < 0x80){
			char cc = (char)c;
			FldInsert(patfield,&cc,1);
		}
		else {
			FldHandleEvent(patfield,e);
		}
		dispindex = 0;
		SearchInit();
		SearchMemo();
		Display();
		break;
	case penDownEvent:
		if(e->screenY > 30){
			handled = SelectMemo(e);
		}
		else {
			handled = false;
		}
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

static Boolean ApplicationHandleEvent(EventPtr e)
{
	Boolean handled = true;
	FormPtr frm;
	Word idx;
	Word c;
	char *s;
	int i;

	switch(e->eType){
	case keyDownEvent:
		switch(c = e->data.keyDown.chr){
		case hard1Chr:
		case hard2Chr:
		case hard3Chr:
		case hard4Chr:
			i = c - hard1Chr;
			if(StrCompare(defaultsearchpat[i],"")==0){
				handled = false;
			}
			else {
				s = FldGetTextPtr(patfield);
				if(s == NULL) s = "";
				if(StrCompare(s,defaultsearchpat[i])==0){
					FldDelete(patfield,0,StrLen(s));
				}
				else {
					FldDelete(patfield,0,StrLen(s));
					FldInsert(patfield,defaultsearchpat[i],StrLen(defaultsearchpat[i]));
				}
			}
			break;
		case pageUpChr:
			dispindex -= MAXLINES;
			if(dispindex < 0) dispindex = 0;
			Display();
			break;
		case pageDownChr:
			if(searchisdone && dispindex+MAXLINES >= nmatchedrecords) break;
			dispindex += MAXLINES;
			SearchMemo();
			Display();
			break;
		default:
			handled = false;
		}
		break;
	case frmLoadEvent:
		frm = FrmInitForm(e->data.frmLoad.formID);
		ErrFatalDisplayIf(frm==NULL,"Null FormPtr");
	        FrmSetActiveForm(frm);
		FrmSetEventHandler(frm, MainFormEvent);

		idx = FrmGetObjectIndex(frm,ID_PATFIELD);
		FrmSetFocus(frm,idx);
		patfield = FrmGetObjectPtr(frm,idx);

	        break;
	case frmOpenEvent:
        	FrmDrawForm(FrmGetActiveForm());

		ErrFatalDisplayIf(patfield==NULL,"Null PatField");
		FldInsert(patfield,pref.searchpat,StrLen(pref.searchpat));
		if(StrLen(pref.searchpat)==0){
			dispindex = 0;
			SearchInit();
			SearchMemo();
			Display();
		}

	        break;
	case menuEvent:
		switch(e->data.menu.itemID){
		case ID_MENU_UNDO:		FldUndo(patfield);			break;
		case ID_MENU_CUT:		FldCut(patfield);			break;
		case ID_MENU_PASTE:		FldPaste(patfield);			break;
		case ID_MENU_COPY:		FldCopy(patfield);			break;
		case ID_MENU_ABOUTHELP:		FrmHelp(ID_ABOUTHELP_STRING);		break;
		case ID_MENU_SEARCHHELP:	FrmHelp(ID_SEARCHHELP_STRING);		break;
		case ID_MENU_MOVEHELP:		FrmHelp(ID_MOVEHELP_STRING);		break;
		case ID_MENU_ADDHELP:		FrmHelp(ID_ADDHELP_STRING);		break;
		case ID_MENU_VERSION:		FrmAlert(ID_ALERT_ABOUTQPOCKET);	break;
		case ID_MENU_PREFERENCES:	SetPreferences();			break;
		default:								break;
		}
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

void StartApplication()
{
	int i,j;
	UShort prefsize;
	DmOpenRef memo;
	int nrecords;
	VoidHand h;
	char *s0,*s,*p;
	Boolean found = false;
	Word length;

	FrmGotoForm(ID_MAINFORM);

	prefsize = sizeof(QPPref);
	if(PrefGetAppPreferences(CREATOR,0,&pref,&prefsize,true) == noPreferenceFound){
		// ErrFatalDisplayIf(true,"Can't open Pref DB");
		StrCopy(pref.searchpat,"");
		StrCopy(pref.memo,"memo");
		pref.movetop = 0;
		PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);
	}

	h = ClipboardGetItem(clipboardText,&length);
	if(length > 0){
		if(length > 15) length = 15;
		s = MemHandleLock(h);
		StrNCopy(pref.searchpat,s,length);
		pref.searchpat[length] = '\0';
		MemHandleUnlock(h);
		ClipboardAddItem(clipboardText,"",0);
	}

	// Open POBox dictionaries... ldic may by NULL
	ldic = DmOpenDatabaseByTypeCreator(LDICTYPE,POBOXCREATOR,dmModeReadOnly);
	dic = DmOpenDatabaseByTypeCreator(DICTYPE,POBOXCREATOR,dmModeReadOnly);
	// ErrFatalDisplayIf(dic==NULL,"Can't open PBInline DB");
	if(dic){
		//
		//	ĥοƬʸĴ
		//
		nextra = DmNumRecords(dic) - 0xa00;
		if(nextra > MAXEXTRA) nextra = MAXEXTRA;
		for(i=0;i< nextra;i++){
			unsigned char *s0;
			VoidHand h;
			h = DmQueryRecord(dic,0xa00+i);
			ErrFatalDisplayIf(h==NULL,"Can't open extra dictionary area");
			s0 = MemHandleLock(h);
			extra[i] = *s0;
			MemHandleUnlock(h);
		}
	}

	//
	//	Graffiti Shift Indicator
	// 	
	GsiSetLocation(143,15);
	GsiEnable(false);

	for(i=0;i<4;i++){
		defaultsearchpat[i][0] = '\0';
	}

#define QPPATID "QPocketPattern\n"
	//
	// Ģǡ١ץ
	//
	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	ErrFatalDisplayIf(memo==NULL,"No memo DB");

	nrecords = DmNumRecords(memo);
	for(i=0;i<nrecords && !found;i++){
		h = DmQueryRecord(memo,i);
		if(h && (s0 = MemHandleLock(h))){
			int size = MemPtrSize(s0);
			if(size >= StrLen(QPPATID) && StrNCompare(s0,QPPATID,StrLen(QPPATID))==0){
				found = true;
				s = s0 + StrLen(QPPATID);
				for(j=0;j<4;j++){
					p = defaultsearchpat[j];
					while(*s != '\n' && s-s0 < size) *p++ = *s++;
					*p = '\0';
					s++;
				}
			}
			MemHandleUnlock(h);
		}
	}
	DmCloseDatabase(memo);
}

void StopApplication()
{
	char *s = FldGetTextPtr(patfield);
	StrCopy(pref.searchpat,s ? s : "");
	PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);

	if(dic) DmCloseDatabase(dic);
	if(ldic) DmCloseDatabase(ldic);
}

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	EventType event;
	Word error;
	tDropLaunchCmdParamPtr param;
	LocalID appid;
	unsigned short appcardno;
	DmSearchStateType state;

	switch(cmd){
	case sysAppLaunchCmdNormalLaunch:
		StartApplication();
		do {
			EvtGetEvent(&event, evtWaitForever);
			if (ApplicationHandleEvent(&event)) continue;
			if (SysHandleEvent(&event)) continue;
			if (MenuHandleEvent(NULL, &event, &error)) continue;
			FrmDispatchEvent(&event);
		}
		while (event.eType != appStopEvent);
		StopApplication();
		return 0;

	case dDropLaunchSupportCmd: // D&D⥸塼븡ΤȤ
		return dYes_Support;
	case dDropLaunchCmd: // D&D⥸塼ƤӽФ
		param = (tDropLaunchCmdParamPtr)cmdPBP;
		ClipboardAddItem(clipboardText,param->srcText,param->srcTextLength);
		DmGetNextDatabaseByTypeCreator(true,&state,'appl',CREATOR,false,&appcardno,&appid);
		SysUIAppSwitch(appcardno,appid,sysAppLaunchCmdNormalLaunch,NULL);
		return 0;
	default:
		return 0;
	}
}

void SearchInit()
{
	nmatchedrecords = 0;
	searchisdone = false;
}

void SearchMemo()		// dispindex1ڡʬmemorecord[]˳Ǽ
{
	int n,i;
	DmOpenRef memo;
	VoidHand h;
	int nrecords;
	unsigned char *pat,*s,*s0;
	int startrecord;
	int size;
	int matchpos;
	UShort attr;

	// ˸ߤʤ鲿⤷ʤ
	if(searchisdone) return;
	if(dispindex+MAXLINES <= nmatchedrecords) return;

	//
	// Ģǡ١򥪡ץ󤷤nmatchedrecordsʹdispindex+MAXLINESޤǤ򸡺
	//
	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	if(memo == NULL) return;

	pat = FldGetTextPtr(patfield);
	if(pat == NULL) pat = "";
	StrCopy(pref.searchpat,pat);
	MakeSearchPat(pat);

	nrecords = DmNumRecords(memo);
	if(nmatchedrecords == 0){
		startrecord = nrecords - 1;
	}
	else {
		startrecord = memorecord[nmatchedrecords-1]-1;
	}
	for(n=startrecord;
		nmatchedrecords < dispindex+MAXLINES &&
		nmatchedrecords < MAXMATCHEDRECORDS && n >= 0;n--){
		DmRecordInfo(memo,n,&attr,NULL,NULL);
		if((attr & dmRecAttrDelete) || attr & dmRecAttrSecret)
			continue;
		h = DmQueryRecord(memo,n);
		if(h && (s0 = MemHandleLock(h))){
			size = MemPtrSize(s0);
			if(*pat == NULL){
				memorecord[nmatchedrecords] = n;
				memorecordpos[nmatchedrecords] = 0;
				nmatchedrecords++;
			}
			else if((matchpos = acsearch_match_size(s0,size)) >= 0){
				memorecord[nmatchedrecords] = n;
				memorecordpos[nmatchedrecords] = matchpos;
				nmatchedrecords++;
			}
			MemHandleUnlock(h);
		}
	}
	if(n < 0)
		searchisdone = true;

	DmCloseDatabase(memo);
}

void Display()
{
	DmOpenRef memo;
	VoidHand h;
	unsigned char *s,*s0;
	int i,l;
	int size;
	RectangleType r;

	// ˸ߤʤ鲿⤷ʤ
//	if(searchisdone) return;
//	if(dispindex+MAXLINES <= nmatchedrecords) return;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	if(memo == NULL) return;

	RctSetRectangle(&r,0,28,156,128);
	WinEraseRectangle(&r,0);

	for(i=dispindex,l=0;i<nmatchedrecords && l<MAXLINES;i++,l++){
		h = DmQueryRecord(memo,memorecord[i]);
		if(h && (s0 = MemHandleLock(h))){
			size = MemPtrSize(s0);
			s = s0;
			while(*s != '\n' && s-s0 < size) s++;
			WinDrawChars(s0,s-s0,3,l*10+30);
			MemHandleUnlock(h);
		}
	}
	DmCloseDatabase(memo);
}

//
//	Search POBox dictionaries and make the transition table.
//
MakeSearchPat(char *pat)
{
	register unsigned char *s,*p;
	DmOpenRef ds;
	int havespace = 0;
	int resid;
	VoidHand h;

	if(pat == NULL || *pat == NULL) return;

	acsearch_beginpat();
	acsearch_addpat(pat);

	if(dic){
		//
		// ñ켭/ĥñ켭δޥå
		//
		resid = (int)(*pat);

		ds = (resid < 0x100 && ldic ? ldic : dic);

		while(havespace == 0 && resid){
			h = DmQueryRecord(ds,resid);
			if(h && (s = MemHandleLock(h))){
				while(*s){ // DBκǸNULL
					for(p = pat;*p && *p == *s; p++,s++);
					if(*p == '\0'){
						for(;*s && *s != '\002';s++);
						s++;
						havespace = acsearch_addpat(s);
						if(havespace != 0){
							break;
						}
					}
					for(;*s;s++);
					s++;
				}
				MemHandleUnlock(h);
			}
			//
			// ñ켭򤵤
			//
			resid = NextDictRecord(resid,(int)(*pat));
			ds = dic;
		}
	}
	acsearch_endpat();
}

int
NextDictRecord(int resid, int c)
{
	if(resid == c){
		resid = 0xa00;
	}
	else {
		resid++;
	}
	for(;resid < 0xa00 + nextra;resid++){
		if(extra[resid - 0xa00] == c) return resid;
	}
	return 0;
}

void
LaunchMemo(int recordno, int pos)
{
	GoToParamsType *cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
	DmSearchStateType state;

	DmGetNextDatabaseByTypeCreator(true,&state,'appl',
		StringToLong(pref.memo),false,&memoappcardno,&memoappid);
	cmdPBP->searchStrLen = 0;
	cmdPBP->dbCardNo = memodbcardno;
	cmdPBP->dbID = memodbid;
	cmdPBP->recordNum = recordno;
	cmdPBP->matchPos = pos;
	cmdPBP->matchFieldNum = 0; 
	cmdPBP->matchCustom = 0;
	MemPtrSetOwner((VoidPtr)cmdPBP,0);
	SysUIAppSwitch(memoappcardno,memoappid,sysAppLaunchCmdGoTo,(Ptr)cmdPBP);
}

static VoidPtr GetObjectPtr(Word objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static void
SetPreferences()
{
	FormPtr prefform;

	Word id;
	ControlPtr movetop;
	FieldPtr memo;

	prefform = FrmInitForm(ID_PREFSFORM);
	ErrFatalDisplayIf(prefform==0,"No prefform");
	FrmSetActiveForm(prefform);

	movetop = (ControlPtr)GetObjectPtr(ID_CHECKBOX_MOVETOP);
	CtlSetValue(movetop,pref.movetop ? 1 : 0);
	memo = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
	FldInsert(memo,pref.memo,StrLen(pref.memo));

	FrmDrawForm(prefform);
	id = FrmDoDialog(prefform);

	if(id == ID_BUTTON_PREF_OK){
		StrCopy(pref.memo,FldGetTextPtr(memo));
		pref.movetop = CtlGetValue(movetop);
		PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);
	}

	FrmReturnToForm(NULL);
}


